<template>
  <button
    :class="{
      link: true,
      opened: opened
    }"
    @click="toggle"
  >
    <div class="icon">
      <Icon size="28px"
      :src="opened?'chevron-double-left':'chevron-double-right'"
      :color="opened?'var(--color)':'#F4F5F7'"/>
    </div>
    <span>
      {{ opened ? "Свернуть меню" : "Раскрыть меню" }}
    </span>
  </button>
</template>

<script>
import Icon from "../Icon";
import { mapState, mapActions } from 'vuex'

export default {
  components: { Icon },
  props: {
    href: {
      type: String,
      default: "#"
    },
    caption: {
      type: String,
      default: "Link"
    }
  },
  setup() {
    return {};
  },
  computed: {
    ...mapState('navigation', {
      opened: 'navOpened'
    })
  },
  methods: {
    ...mapActions('navigation', [
      'setNav'
    ]),
    toggle(){
      this.setNav(!this.opened)
    }
  }
};
</script>

<style scoped lang="scss">
.link {
  position: relative;
  display: flex;
  align-items: center;
  justify-content: flex-start;
  width: 200px;

  box-shadow: inset 0px 0px 0px #2D9CDB00;

  text-decoration: none;
  color: var(--color);
  background: none;
  border: none;
  padding: 0;
  outline: none;

  &::after{
    content: "";
    position: absolute;
    display: block;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background: #2D9CDB;

    transition: 0.3s ease all;
    transform: translateX(-100%);
  }

  &:hover{
    &::after{
      transform: translateX(calc(-100% + 4px));
    }
  }
}
.icon{
  position: relative;
  width: 44px;
  height: 44px;
  z-index: 2;

  display: flex;
  justify-content: center;
  align-items: center;
}
span{
  position: relative;
  z-index: 2;
  margin-left: 8px;
}
</style>
